#
#  USBUART.py
#  
#
# Copyright (c) 2009, Revolution Robotics, Inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, is permitted.
#
# THIS SOFTWARE IS PROVIDED BY Revolution Robotics, Inc. ''AS IS'' AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Revolution Robotics, Inc. BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# As of 2009-10-15:
# This requires pyserial to be installed, available from http://pyserial.sourceforge.net/
# This requires the CP2102 VCP Drivers to be installed (for Mac & Windows) available
# from https://www.silabs.com/products/mcu/Pages/USBtoUARTBridgeVCPDrivers.aspx
#

import serial
from time import sleep

motors = serial.Serial()

motors.baudrate = 9600
if os.name == 'posix':
	if os.uname()[0] == 'Darwin':
		self.motors.port = '/dev/cu.SLAB_USBtoUART'
	elif os.uname()[0] == 'Linux':
		self.motors.port = '/dev/ttyUSB0'
	else:
		print "ERROR: %s Unknown OS!", os.uname()[1]
		return
elif os.name == 'nt':
	self.motors.port = 0	#COM1 = 0, etc.
motors.timeout = 0.5
motors.open()


########### PROGRAM CORE HERE
#motors.write(cmd)

#data = sensor.readline()

###########

sleep(1)	# sometimes data isn't flushed if you don't pause before closing the serial device

motors.close()